#include "Bullet.h"
#include <math.h>

Bullet::Bullet() : Entity()
{
	spriteData.width = BulletNS::WIDTH;
	spriteData.height = BulletNS::HEIGHT;
	spriteData.x = BulletNS::X;
	spriteData.y = BulletNS::Y;
	velocity.x = 0;
	velocity.y = 0;
	currentFrame = BulletNS::CURRENT_FRAME;
	radius = BulletNS::WIDTH/2.0;
	collisionType = entityNS::BOX;
	edge = BULLET_BOX;
	mass = BulletNS::MASS;

}

bool Bullet::initialize(Game *gamePtr, int width, int height, int ncols,
					  TextureManager *textureM)
{ 	return(Entity::initialize(gamePtr, width, height, ncols, textureM)); }


void Bullet::draw()
{
	Image::draw();
}

void Bullet::update(float frameTime)
{
	Entity::update(frameTime);
	spriteData.x += velocity.x * frameTime;
	spriteData.y += velocity.y * frameTime;
}

void Bullet::setPaulVeloc(float direction, float frameTime)
{
	spriteData.angle = direction;
	velocity.y = -(float)cos(spriteData.angle) * BulletNS::paulSPEED;
	velocity.x = (float)sin(spriteData.angle) * BulletNS::paulSPEED;
}

void Bullet::setSolVeloc(float direction, float frameTime)
{
	spriteData.angle = direction;
	velocity.y = -(float)cos(spriteData.angle) * BulletNS::solSPEED;
	velocity.x = (float)sin(spriteData.angle) * BulletNS::solSPEED;
}

void Bullet::setCanVeloc(float direction, float frameTime)
{
	spriteData.angle = direction;
	velocity.y = -(float)cos(spriteData.angle) * BulletNS::canSPEED;
	velocity.x = (float)sin(spriteData.angle) * BulletNS::canSPEED;
}