#ifndef _BULLET_H             // file is included in more than one place
#define _BULLET_H
#define WIN32_LEAN_AND_MEAN

#include "entity.h"
#include "game.h"
#include "constants.h"

namespace BulletNS
{
	const int	WIDTH = 96;
	const int	HEIGHT = 96;
	const int   LASERW = 64;
	const int   LASERH = 80;
	const float	paulSPEED = 300.0F;
	const float solSPEED = 300.0F;
	const float canSPEED = 500.0F;
	const float X = -10000;   // location on screen
    const float Y = -10000;
	const int	TEXTURE_COLS = 10;
	const int	CURRENT_FRAME = 151;
	const int   LASER_COLS = 8;
	const int   LASER_FRAME = 32;
	const float	MASS = 1.0f;
}

class Bullet : public Entity
{
private:

public:
    // constructor
    Bullet();

    // inherited member functions
    virtual void draw();
    virtual bool initialize(Game *gamePtr, int width, int height, int ncols,
                            TextureManager *textureM);

    // update ship position and angle
    void update(float frameTime);
	void setPaulVeloc(float direction, float frameTime);
	void setSolVeloc(float direction, float frameTime);
	void setCanVeloc(float direction, float frameTime);
};
#endif