#include "cannon.h"

const float pi = 3.14159265359f;

//=============================================================================
// default constructor
//=============================================================================
Cannon::Cannon() : Entity()
{
    spriteData.width = cannonNS::WIDTH;           // size of cannon
    spriteData.height = cannonNS::HEIGHT;
    spriteData.x = cannonNS::X;                   // location on screen
    spriteData.y = cannonNS::Y;
    spriteData.rect.bottom = cannonNS::HEIGHT;    // rectangle to select parts of an image
    spriteData.rect.right = cannonNS::WIDTH;
    velocity.x = 0;                             // velocity X
    velocity.y = 0;                             // velocity Y
    frameDelay = cannonNS::CANNON_ANIMATION_DELAY;
    startFrame = cannonNS::CANNON_START_FRAME;      // PAUL starts at frame 149
    endFrame     = cannonNS::CANNON_END_FRAME;      // PAUL starts at frame 149
    currentFrame = startFrame;
    radius = cannonNS::WIDTH/2.0;
    mass = cannonNS::MASS;
    collisionType = entityNS::ROTATED_BOX;
	canfiring = false;
}

//=============================================================================
// Initialize the cannon.
// Post: returns true if successful, false if failed
//=============================================================================
bool Cannon::initialize(Game *gamePtr, int width, int height, int ncols,
    TextureManager *textureM)
{
    //shield.initialize(gamePtr->getGraphics(), width, height, ncols, textureM);
    //shield.setFrames(cannonNS::SHIELD_START_FRAME, cannonNS::SHIELD_END_FRAME);
    //shield.setCurrentFrame(cannonNS::SHIELD_START_FRAME);
    //shield.setFrameDelay(cannonNS::SHIELD_ANIMATION_DELAY);
    //shield.setLoop(false);                  // do not loop animation
    return(Entity::initialize(gamePtr, width, height, ncols, textureM));
}

//=============================================================================
// draw cannon
//=============================================================================
void Cannon::draw()
{
    Image::draw();              // draw cannon
    //if(shieldOn)
    //    // draw shield using colorFilter 50% alpha
    //    shield.draw(spriteData, graphicsNS::ALPHA50 & colorFilter);
}

//=============================================================================
// update
// typically called once per frame
// frameTime is used to regulate the speed of movement and animation
//=============================================================================
void Cannon::update(float frameTime)
{
    Entity::update(frameTime);
}

void Cannon::setDirection()
{
	if(currentFrame >= 16 && currentFrame <= 31)
		canshotDir = (currentFrame * 11.25f - 180) * (pi / 180);
	if(currentFrame >=0 && currentFrame <= 15)
		canshotDir = (currentFrame * 11.25f + 180) * (pi / 180);
}