#ifndef _CANNON_H
#define _CANNON_H
#define WIN32_LEAN_AND_MEAN

#include "entity.h"
#include "constants.h"

namespace cannonNS
{
	const int WIDTH = 64;                   // image width
    const int HEIGHT = 80;                  // image height
    const int X = GAME_WIDTH/2 - WIDTH/2;   // location on screen
    const int Y = GAME_HEIGHT/2 - HEIGHT/2;
    const float ROTATION_RATE = (float)PI/4; // radians per second
    const float SPEED = 0;                // 100 pixels per second
    const float MASS = 500.0f;              // mass
    const int   TEXTURE_COLS = 8;           // texture has 10 columns
    const float CANNON_ANIMATION_DELAY = 0.1f;    // time between frames
	const float CANNON_SHOOT_DELAY = 0.05f;
	const int	CANNON_START_FRAME = 0;
	const int   CANNON_END_FRAME = 31;

    const int   CANNON_STAND_FRAME_S = 0;      // CANNON starts at frame 149
    const int   CANNON_STAND_FRAME_SW = 4;      // CANNON starts at frame 149
	const int   CANNON_STAND_FRAME_W = 8;      // CANNON starts at frame 149
	const int   CANNON_STAND_FRAME_NW = 12;      // CANNON starts at frame 149
	const int   CANNON_STAND_FRAME_N = 16;      // CANNON starts at frame 149
	const int   CANNON_STAND_FRAME_NE = 20;      // CANNON starts at frame 149
	const int   CANNON_STAND_FRAME_E = 24;      // CANNON starts at frame 149
	const int   CANNON_STAND_FRAME_SE = 28;      // SOLDIER starts at frame 149
}

class Cannon : public Entity
{
private:
	float canshotDir;
	bool  canfiring;
public:
	// constructor
	Cannon();

	//inherited member functions
	virtual void draw();
	virtual bool initialize(Game *gamePtr, int width, int height, int ncols,
                            TextureManager *textureM);
    void update(float frameTime);

	void setVelocityX(float v)  {velocity.x = v;}
	void setVelocityY(float v)	{velocity.y = v;}

	void setFiring(bool b) {canfiring = b;}

	float getFiring()	{return canfiring;}

	void setDirection();

	float getDirection() {return canshotDir;}
};

#endif